=== debian/changelog ===
vvenc-dmo (1.14.0-dmo2) unstable; urgency=medium

  * Add nlohmann-json3-dev to Build-Depends and enable tests.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Jan 2026 15:46:29 +0100

vvenc-dmo (1.14.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Jan 2026 14:47:16 +0100
