=== debian/control ===
Source: vvenc-dmo
Section: video
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/fraunhoferhhi/vvenc/releases
Standards-Version: 4.7.3
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build,
 nlohmann-json3-dev, quilt,

Package: vvenc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder (VVenC)
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.

Package: libvvenc1.14
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder - runtime files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.
 .
 This package contains the shared library.

Package: libvvenc-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libvvenc1.14 (= ${binary:Version}), ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder - devel files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.
 .
 This package contains headers and a static library.
