=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DVVENC_ENABLE_INSTALL=ON \
	-DVVENC_ENABLE_LINK_TIME_OPT=ON \
	-DVVENC_ENABLE_THIRDPARTY_JSON=SYSTEM \
	-DVVENC_ENABLE_WERROR=OFF

#	exit 1

override_dh_clean:
	dh_clean

	rm -rf bin
	rm -rf lib

#override_dh_auto_test:
